'use strict';

var ListaDocumentoController = angular.module('ListaDocumentoController', []);

ListaDocumentoController.controller('ListaDocumentoCtrl', ['$scope', '$routeParams', 'Construcao', 'UploadApp', 'CacheApp',
  ($scope, $routeParams, Construcao, UploadApp, CacheApp) => {

    $scope.excluirDocumento = (documento) => {
        $scope.msgBoxPergunta('Documento da ' + $scope.construcao.TipoDescricao, 'Confirma exclusão do documento?'
            , () => {
                Construcao.delDocumento(documento.Id,
                    (data) => {
                        $scope.getDocumentos();
                    });
            }
            , () => {
            });
    }

    $scope.adicionarDocumento = () => {
        var idCount = $scope.documentos.length;
        $scope.documentos.unshift({
            Novo: true,
            Id: 0,
            IdConstrucao: $scope.construcao.Id,
            Descricao: '',
            IdCount: idCount
        });
    }

    $scope.cancelaDocumento = (documento) => {
        var idx = $scope.documentos.indexOf(documento)
        $scope.documentos.splice(idx, 1);
    }

    $scope.salvarDocumento = (documento) => {
        if (documento.file) {
            $scope.progress = 0
            UploadApp.UploadDocumento(documento,
                (progress) => {
                    $scope.progress = progress
                },
                (result) => {
                    $scope.getDocumentos()
                },
                (error) => {}
            )
        }
    }

    $scope.getDocumentos = () => {
        Construcao.getDocumentos($scope.construcao.Id,
            (data) => {
                console.log(data)
                $scope.documentos = data.Instance;
                $scope.documentos.forEach((doc) => {
                    doc.Nome = doc.Arquivo.split('/')[doc.Arquivo.split('/').length - 1]
                })
            }
        )
    }

    $scope.downloadDocumento = (documento) => {
        window.open(documento.Arquivo, '_blank');
    }

    $scope.getListaConstrucao = (callBack) => {
        $scope.sessao = CacheApp.getSessao()
        var params = {
            permissao: ($scope.sessao.TipoPlano == 1 || $scope.sessao.ContaAdmin) ? undefined : 'GET_DOCUMENTO',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.documento = undefined;
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.documento = []
        $scope.construcao = obra
        CacheApp.setConstrucao($scope.construcao)

        $scope.HtmlManterObra = undefined

        $scope.getDocumentos();
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra()
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else
                $scope.documentos = []
        })
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim;

        $scope.loadObra()

        // $scope.documentos = [];
        // $scope.construcao = CacheApp.getConstrucao();
        // $scope.getDocumentos();
    });

  }]);
